// comtx.h

#ifndef __COMTX_H__
#define __COMTX_H__

//{### forward decs

typedef struct IUnknown IUnknown;

typedef struct ICreateTypeInfo	ICreateTypeInfo;
typedef struct ICreateTypeInfo2	ICreateTypeInfo2;
typedef struct ICreateTypeLib	ICreateTypeLib;
typedef struct ICreateTypeLib2	ICreateTypeLib2;
typedef struct IDispatch		IDispatch;
typedef struct IEnumVARIANT		IEnumVARIANT;
typedef struct ITypeComp		ITypeComp;
typedef struct ITypeInfo		ITypeInfo;
typedef struct ITypeInfo2		ITypeInfo2;
typedef struct ITypeLib			ITypeLib;
typedef struct ITypeLib2		ITypeLib2;
typedef struct ITypeChangeEvents	ITypeChangeEvents;
typedef struct IErrorInfo		IErrorInfo;
typedef struct ICreateErrorInfo	ICreateErrorInfo;
typedef struct ISupportErrorInfo	ISupportErrorInfo;
typedef struct ITypeFactory		ITypeFactory;
typedef struct ITypeMarshal		ITypeMarshal;
typedef struct IRecordInfo		IRecordInfo;
typedef struct IErrorLog		IErrorLog;
typedef struct IPropertyBag		IPropertyBag;

typedef struct IStream			IStream;

//{### typedefs

//## OLECHAR

typedef WCHAR	OLECHAR;
typedef OLECHAR	*LPOLESTR;
typedef const OLECHAR	*LPCOLESTR;

#define OLESTR(str) L##str

//## SCODE

typedef struct _COAUTHIDENTITY {
	USHORT *User;
	ULONG UserLength;
	USHORT *Domain;
	ULONG DomainLength;
	USHORT *Password;
	ULONG PasswordLength;
	ULONG Flags;
} COAUTHIDENTITY;

typedef struct _COAUTHINFO {
	DWORD dwAuthnSvc;
	DWORD dwAuthzSvc;
	LPWSTR pwszServerPrincName;
	DWORD dwAuthnLevel;
	DWORD dwImpersonationLevel;
	COAUTHIDENTITY *pAuthIdentityData;
	DWORD dwCapabilities;
} COAUTHINFO;

typedef LONG	SCODE;
typedef SCODE	*PSCODE;

//## HRESULT

typedef LONG	HRESULT;

//## CLSCTX

typedef enum tagCLSCTX {
	CLSCTX_INPROC_SERVER		= 0x1,
	CLSCTX_INPROC_HANDLER		= 0x2,
	CLSCTX_LOCAL_SERVER			= 0x4,
	CLSCTX_INPROC_SERVER16		= 0x8,
	CLSCTX_REMOTE_SERVER		= 0x10,
	CLSCTX_INPROC_HANDLER16		= 0x20,
	CLSCTX_INPROC_SERVERX86		= 0x40,
	CLSCTX_INPROC_HANDLERX86	= 0x80,
	CLSCTX_ESERVER_HANDLER		= 0x100,
	CLSCTX_RESERVED				= 0x200,
	CLSCTX_NO_CODE_DOWNLOAD		= 0x400,
	CLSCTX_NO_WX86_TRANSLATION	= 0x800,
	CLSCTX_NO_CUSTOM_MARSHAL	= 0x1000,
	CLSCTX_ENABLE_CODE_DOWNLOAD	= 0x2000,
	CLSCTX_NO_FAILURE_LOG		= 0x4000,
	CLSCTX_DISABLE_AAA			= 0x8000,
	CLSCTX_ENABLE_AAA			= 0x10000,
	CLSCTX_FROM_DEFAULT_CONTEXT	= 0x20000
} CLSCTX;

#define CLSCTX_ALL	(CLSCTX_INPROC_SERVER| \
					CLSCTX_INPROC_HANDLER| \
					CLSCTX_LOCAL_SERVER| \
					CLSCTX_REMOTE_SERVER)


//## LCID

typedef DWORD	LCID;

typedef USHORT	LANGID;

//## BSTR

typedef OLECHAR	*BSTR;
typedef BSTR	*LPBSTR;

//## IID/CLSID

typedef GUID IID;
typedef IID *LPIID;
#define IID_NULL	GUID_NULL

typedef IID CLSID;
typedef CLSID *LPCLSID;
#define CLSID_NULL	GUID_NULL

#define REFIID		const IID*
#define REFCLSID	const IID*

#define MIDL_DEFINE_GUID(type,name,l,w1,w2,b1,b2,b3,b4,b5,b6,b7,b8) \
        const type name = {l,w1,w2,{b1,b2,b3,b4,b5,b6,b7,b8}}



#define BEGIN_INTERFACE
#define END_INTERFACE


//## BSTR

#define OLECHAR			WCHAR

typedef OLECHAR			*LPOLESTR;
typedef const OLECHAR	*LPCOLESTR;

typedef OLECHAR *BSTR;



//## VARIANT


typedef union tagCY {
	struct {
		unsigned long Lo;
		long          Hi;
	};  
	LONGLONG int64;
} CY; 

typedef CY CURRENCY;


typedef unsigned short	VARTYPE;

typedef short	VARIANT_BOOL;
typedef VARIANT_BOOL	_VARIANT_BOOL;

#define VARIANT_TRUE ((VARIANT_BOOL)-1)
#define VARIANT_FALSE ((VARIANT_BOOL)0)

typedef struct tagVARIANT VARIANT;

typedef long FLOAT;
typedef long DOUBLE;
typedef unsigned long ULONGLONG;
typedef double DATE;

typedef struct tagSAFEARRAYBOUND {
	ULONG cElements;
	LONG lLbound;
} SAFEARRAYBOUND;

typedef struct tagSAFEARRAYBOUND *LPSAFEARRAYBOUND;

typedef struct tagSAFEARRAY {
	USHORT cDims;
	USHORT fFeatures;
	ULONG cbElements;
	ULONG cLocks;
	PVOID pvData;
	SAFEARRAYBOUND rgsabound[1];
} SAFEARRAY;

typedef SAFEARRAY *LPSAFEARRAY;

typedef struct tagDEC {
	USHORT wReserved;
	union {
		struct {
			BYTE scale;
			BYTE sign;
		};
		USHORT signscale;
	};
	ULONG Hi32;
	union {
		struct {
			ULONG Lo32;
			ULONG Mid32;
		};
		ULONGLONG Lo64;
	};
} DECIMAL;

#define DECIMAL_NEG ((BYTE)0x80)

#define DECIMAL_SETZERO(dec) \
		{(dec).Lo64 = 0; (dec).Hi32 = 0; (dec).signscale = 0;}

typedef DECIMAL *LPDECIMAL;

struct tagVARIANT {
	union {
		struct __tagVARIANT {
			VARTYPE vt;
			WORD wReserved1;
			WORD wReserved2;
			WORD wReserved3;
			union {
				LONGLONG llVal;
				LONG lVal;
				BYTE bVal;
				SHORT iVal;
				FLOAT fltVal;
				DOUBLE dblVal;
				VARIANT_BOOL boolVal;
				_VARIANT_BOOL bool;
				SCODE scode;
				CY cyVal;
				DATE date;
				BSTR bstrVal;
				IUnknown *punkVal;
				IDispatch *pdispVal;
				SAFEARRAY *parray;
				BYTE *pbVal;
				SHORT *piVal;
				LONG *plVal;
				LONGLONG *pllVal;
				FLOAT *pfltVal;
				DOUBLE *pdblVal;
				VARIANT_BOOL *pboolVal;
				_VARIANT_BOOL *pbool;
				SCODE *pscode;
				CY *pcyVal;
				DATE *pdate;
				BSTR *pbstrVal;
				IUnknown **ppunkVal;
				IDispatch **ppdispVal;
				SAFEARRAY **pparray;
				VARIANT *pvarVal;
				PVOID byref;
				CHAR cVal;
				USHORT uiVal;
				ULONG ulVal;
				ULONGLONG ullVal;
				INT intVal;
				UINT uintVal;
				DECIMAL *pdecVal;
				CHAR *pcVal;
				USHORT *puiVal;
				ULONG *pulVal;
				ULONGLONG *pullVal;
				INT *pintVal;
				UINT *puintVal;
				struct __tagBRECORD {
					PVOID pvRecord;
					IRecordInfo *pRecInfo;
				};
			};
		};
		DECIMAL decVal;
	};
};

typedef VARIANT *LPVARIANT;

typedef VARIANT VARIANTARG;

typedef VARIANT *LPVARIANTARG;


enum VARENUM {
	VT_EMPTY	= 0,
	VT_NULL	= 1,
	VT_I2	= 2,
	VT_I4	= 3,
	VT_R4	= 4,
	VT_R8	= 5,
	VT_CY	= 6,
	VT_DATE	= 7,
	VT_BSTR	= 8,
	VT_DISPATCH	= 9,
	VT_ERROR	= 10,
	VT_BOOL	= 11,
	VT_VARIANT	= 12,
	VT_UNKNOWN	= 13,
	VT_DECIMAL	= 14,
	VT_I1	= 16,
	VT_UI1	= 17,
	VT_UI2	= 18,
	VT_UI4	= 19,
	VT_I8	= 20,
	VT_UI8	= 21,
	VT_INT	= 22,
	VT_UINT	= 23,
	VT_VOID	= 24,
	VT_HRESULT	= 25,
	VT_PTR	= 26,
	VT_SAFEARRAY	= 27,
	VT_CARRAY	= 28,
	VT_USERDEFINED	= 29,
	VT_LPSTR	= 30,
	VT_LPWSTR	= 31,
	VT_RECORD	= 36,
	VT_INT_PTR	= 37,
	VT_UINT_PTR	= 38,
	VT_FILETIME	= 64,
	VT_BLOB	= 65,
	VT_STREAM	= 66,
	VT_STORAGE	= 67,
	VT_STREAMED_OBJECT	= 68,
	VT_STORED_OBJECT	= 69,
	VT_BLOB_OBJECT	= 70,
	VT_CF	= 71,
	VT_CLSID	= 72,
	VT_VERSIONED_STREAM	= 73,
	VT_BSTR_BLOB	= 0xfff,
	VT_VECTOR	= 0x1000,
	VT_ARRAY	= 0x2000,
	VT_BYREF	= 0x4000,
	VT_RESERVED	= 0x8000,
	VT_ILLEGAL	= 0xffff,
	VT_ILLEGALMASKED	= 0xfff,
	VT_TYPEMASK	= 0xfff
};

typedef ULONG	PROPID;


#define V_UNION(X, Y)   ((X)->Y)
#define V_VT(X)         ((X)->vt)
#define V_RECORDINFO(X) ((X)->pRecInfo)
#define V_RECORD(X)     ((X)->pvRecord)

#define V_ISBYREF(X)     (V_VT(X)&VT_BYREF)
#define V_ISARRAY(X)     (V_VT(X)&VT_ARRAY)
#define V_ISVECTOR(X)    (V_VT(X)&VT_VECTOR)
#define V_NONE(X)        V_I2(X)

#define V_UI1(X)         V_UNION(X, bVal)
#define V_UI1REF(X)      V_UNION(X, pbVal)
#define V_I2(X)          V_UNION(X, iVal)
#define V_I2REF(X)       V_UNION(X, piVal)
#define V_I4(X)          V_UNION(X, lVal)
#define V_I4REF(X)       V_UNION(X, plVal)
#define V_I8(X)          V_UNION(X, llVal)
#define V_I8REF(X)       V_UNION(X, pllVal)
#define V_R4(X)          V_UNION(X, fltVal)
#define V_R4REF(X)       V_UNION(X, pfltVal)
#define V_R8(X)          V_UNION(X, dblVal)
#define V_R8REF(X)       V_UNION(X, pdblVal)
#define V_I1(X)          V_UNION(X, cVal)
#define V_I1REF(X)       V_UNION(X, pcVal)
#define V_UI2(X)         V_UNION(X, uiVal)
#define V_UI2REF(X)      V_UNION(X, puiVal)
#define V_UI4(X)         V_UNION(X, ulVal)
#define V_UI4REF(X)      V_UNION(X, pulVal)
#define V_UI8(X)         V_UNION(X, ullVal)
#define V_UI8REF(X)      V_UNION(X, pullVal)
#define V_INT(X)         V_UNION(X, intVal)
#define V_INTREF(X)      V_UNION(X, pintVal)
#define V_UINT(X)        V_UNION(X, uintVal)
#define V_UINTREF(X)     V_UNION(X, puintVal)

#define V_INT_PTR(X)        V_UNION(X, lVal)
#define V_UINT_PTR(X)       V_UNION(X, ulVal)
#define V_INT_PTRREF(X)     V_UNION(X, plVal)
#define V_UINT_PTRREF(X)    V_UNION(X, pulVal)

#define V_CY(X)          V_UNION(X, cyVal)
#define V_CYREF(X)       V_UNION(X, pcyVal)
#define V_DATE(X)        V_UNION(X, date)
#define V_DATEREF(X)     V_UNION(X, pdate)
#define V_BSTR(X)        V_UNION(X, bstrVal)
#define V_BSTRREF(X)     V_UNION(X, pbstrVal)
#define V_DISPATCH(X)    V_UNION(X, pdispVal)
#define V_DISPATCHREF(X) V_UNION(X, ppdispVal)
#define V_ERROR(X)       V_UNION(X, scode)
#define V_ERRORREF(X)    V_UNION(X, pscode)
#define V_BOOL(X)        V_UNION(X, boolVal)
#define V_BOOLREF(X)     V_UNION(X, pboolVal)
#define V_UNKNOWN(X)     V_UNION(X, punkVal)
#define V_UNKNOWNREF(X)  V_UNION(X, ppunkVal)
#define V_VARIANTREF(X)  V_UNION(X, pvarVal)
#define V_ARRAY(X)       V_UNION(X, parray)
#define V_ARRAYREF(X)    V_UNION(X, pparray)
#define V_BYREF(X)       V_UNION(X, byref)

#define V_DECIMAL(X)     V_UNION(X, decVal)
#define V_DECIMALREF(X)  V_UNION(X, pdecVal)

//## DISPID

typedef long DISPID;

typedef struct tagDISPPARAMS {
	VARIANTARG	*rgvarg;
	DISPID		*rgdispidNamedArgs;
	unsigned int	cArgs;
	unsigned int	cNamedArgs;
} DISPPARAMS;

//## EXCEPINFO

typedef struct tagEXCEPINFO {
	WORD	wCode;
	WORD	wReserved;
	BSTR	bstrSource;
	BSTR	bstrDescription;
	BSTR	bstrHelpFile;
	DWORD	dwHelpContext;
	PVOID	pvReserved;
	HRESULT (__stdcall *pfnDeferredFillIn)(struct tagEXCEPINFO *);
	SCODE	scode;
} EXCEPINFO, *LPEXCEPINFO;



typedef struct _COSERVERINFO {
	DWORD dwReserved1;
	LPWSTR pwszName;
	COAUTHINFO *pAuthInfo;
	DWORD dwReserved2;
} COSERVERINFO;


//{### interfaces

#define BEGIN_INTERFACE
#define END_INTERFACE

//## IUnknown

MIDL_DEFINE_GUID(IID, IID_IUnknown,0x00000000,0x0000,0x0000,0x00,0x00,0xC0,0x00,0x00,0x00,0x00,0x46);

typedef struct IUnknown IUnknown;

typedef struct IUnknownVtbl {
	BEGIN_INTERFACE
	HRESULT	("stdole2.tlb" WINAPI *QueryInterface)(IUnknown *This, REFIID riid, void **ppvObject);
	ULONG	("stdole2.tlb" WINAPI *AddRef)(IUnknown *This);
	ULONG	("stdole2.tlb" WINAPI *Release)(IUnknown *This);
	END_INTERFACE
} IUnknownVtbl;

struct IUnknown {
	const IUnknownVtbl *lpVtbl;
};

typedef IUnknown *LPUNKNOWN;

#define IUnknown_QueryInterface(This,riid,ppvObject)	\
	((This)->lpVtbl->QueryInterface)(This,riid,ppvObject)

#define IUnknown_AddRef(This)	\
	((This)->lpVtbl->AddRef)(This)

#define IUnknown_Release(This)	\
	((This)->lpVtbl->Release)(This)

//## IDispatch

MIDL_DEFINE_GUID(IID, IID_IDispatch,0x00020400,0x0000,0x0000,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46);

typedef struct IDispatch IDispatch;

typedef struct IDispatchVtbl {
	BEGIN_INTERFACE
	HRESULT	("stdole2.tlb" WINAPI *QueryInterface)(IDispatch *This, REFIID riid, void **ppvObject);
	ULONG	("stdole2.tlb" WINAPI *AddRef)(IDispatch *This);
	ULONG	("stdole2.tlb" WINAPI *Release)(IDispatch *This);
	HRESULT ("stdole2.tlb" WINAPI *GetTypeInfoCount)(IDispatch *This, UINT *pctinfo);
	HRESULT ("stdole2.tlb" WINAPI *GetTypeInfo)(IDispatch *This, UINT iTInfo,
		LCID lcid, ITypeInfo **ppTInfo);
	HRESULT ("stdole2.tlb" WINAPI *GetIDsOfNames)(IDispatch *This, REFIID riid,
		LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgDispId);
	HRESULT ("stdole2.tlb" WINAPI *Invoke)(IDispatch *This, DISPID dispIdMember, REFIID riid,
		LCID lcid, WORD wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo,
		UINT *puArgErr);
	END_INTERFACE
} IDispatchVtbl;

struct IDispatch {
	const struct IDispatchVtbl *lpVtbl;
};

#define IDispatch_QueryInterface(This,riid,ppvObject)	\
	((This)->lpVtbl->QueryInterface)(This,riid,ppvObject)

#define IDispatch_AddRef(This)	\
	((This)->lpVtbl->AddRef)(This)

#define IDispatch_Release(This)	\
	((This)->lpVtbl->Release)(This)


#define IDispatch_GetTypeInfoCount(This,pctinfo)	\
	((This)->lpVtbl->GetTypeInfoCount)(This,pctinfo)

#define IDispatch_GetTypeInfo(This,iTInfo,lcid,ppTInfo)	\
	((This)->lpVtbl->GetTypeInfo)(This,iTInfo,lcid,ppTInfo)

#define IDispatch_GetIDsOfNames(This,riid,rgszNames,cNames,lcid,rgDispId)	\
	((This)->lpVtbl->GetIDsOfNames)(This,riid,rgszNames,cNames,lcid,rgDispId)

#define IDispatch_Invoke(This,dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr)	\
	((This)->lpVtbl->Invoke)(This,dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr)



//{### APIs

extern "ole32.dll" {
	HRESULT	WINAPI	CoInitialize(LPVOID pvReserved);
	void	WINAPI	CoUninitialize(void);
	HRESULT	WINAPI	CoCreateInstance(REFCLSID rclsid, LPUNKNOWN pUnkOuter, DWORD dwClsContext,
		REFIID riid, LPVOID *ppv);
	HRESULT	WINAPI	CoGetClassObject(REFCLSID rclsid, DWORD dwClsContext, COSERVERINFO *pServerInfo,
		REFIID riid, LPVOID *ppv);
};

extern "oleaut32.dll" {
	HRESULT	WINAPI	GetActiveObject(REFCLSID rclsid, void *pvReserved, IUnknown **ppunk);
	
	BSTR	WINAPI	SysAllocString(const OLECHAR *sz);
	BSTR	WINAPI	SysAllocStringByteLen(LPCSTR psz, unsigned int len);
	BSTR	WINAPI	SysAllocStringLen(const OLECHAR *pch, unsigned int cch);
	VOID	WINAPI	SysFreeString(BSTR bstr);
	INT		WINAPI	SysReAllocString(BSTR *pbstr, const OLECHAR *psz);
	INT		WINAPI	SysReAllocStringLen(BSTR *pbstr, const OLECHAR *psz, unsigned int cch);
	UINT	WINAPI	SysStringByteLen(BSTR bstr);
	UINT	WINAPI	SysStringLen(BSTR bstr);
	
	HRESULT WINAPI	VariantChangeType(VARIANTARG *pvargDest, VARIANTARG *pvarSrc,
		unsigned short wFlags, VARTYPE vt);
	HRESULT WINAPI	VariantChangeTypeEx(VARIANTARG *pvargDest, VARIANTARG *pvarSrc, LCID lcid,
		unsigned short wFlags, VARTYPE  vt);
	HRESULT WINAPI	VariantClear(VARIANTARG *pvarg);
	HRESULT WINAPI	VariantCopy(VARIANTARG *pvargDest, VARIANTARG *pvargSrc);
	HRESULT WINAPI	VariantCopyInd(VARIANT *pvarDest, VARIANTARG *pvargSrc);
	VOID	WINAPI	VariantInit(VARIANTARG *pvarg);
}

extern "atl.dll" {
	BOOL	WINAPI	AtlAxWinInit(void);
	HRESULT	WINAPI	AtlAxGetControl(HWND h, IUnknown** pp);
	HRESULT WINAPI	AtlAxCreateControl(LPCOLESTR lpszName, HWND hWnd, IStream* pStream,
		IUnknown** ppUnkContainer);
}

//## Utils

//  VARIANT̑͂܂ƂłĂ̂ǂmFĂ܂B

VARIANTARG* variantNew(void)
{
	VARIANTARG *pVar = malloc(sizeof(VARIANTARG));
	if (pVar) {
		VariantInit(pVar);
	}
	return pVar;
}


void variantDelete(VARIANTARG *pVar)
{
	if (!pVar) return;
	VariantClear(pVar);
	free(pVar);
}


#endif // __COMTX_H__
